#!/bin/sh

IP4TABLES=/sbin/iptables
IP6TABLES=/sbin/ip6tables
ACTION=$1
USER=$2
IP=$3
LOG_FILE=/var/ossec/logs/active-responses.log


# Log event
echo "`date` $0 $1 $2 $3 $4 $5" >> ${LOG_FILE}


# Checking for an IP
if [ "x${IP}" = "x" ]; then
   echo "$0: <action> <username> <ip>" 
   exit 1;
fi

# Blocking IP
if [ "x${ACTION}" != "xadd" -a "x${ACTION}" != "xdelete" ]; then
   echo "$0: invalid action: ${ACTION}"
   exit 1;
fi

case "${IP}" in
    *:* ) IPTABLES=$IP6TABLES;;
    *.* ) IPTABLES=$IP4TABLES;;
    * ) echo "`date` Unable to run active response (invalid IP: '${IP}')." >> ${LOG_FILE} && exit 1;;
esac


# Does the AR table exist
if ! ${IPTABLES} -L ASL-ACTIVE-RESPONSE 2>/dev/null | grep -q DROP ; then
	${IPTABLES} -N ASL-ACTIVE-RESPONSE >/dev/null

	${IPTABLES} -A ASL-ACTIVE-RESPONSE -j DROP
fi

# Add event
if [ "x${ACTION}" = "xadd" ]; then
	${IPTABLES} -I INPUT 1 -s ${IP} -j ASL-ACTIVE-RESPONSE

# Delete event
else
	${IPTABLES} -D INPUT -s ${IP} -j ASL-ACTIVE-RESPONSE

fi


